
#include "config.h"
#include "EEPROM.h"

#define EE_ADDRESS1	0x0200

#define CMD_IDLE    0            
#define CMD_READ    1              
#define CMD_PROGRAM 2               
#define CMD_ERASE   3              

#define ENABLE_IAP 0x80           //if SYSCLK<30MHz
extern int   xdata g_x,g_y,g_z;		//ǽ
extern float xdata a_x,a_y;			//ǶȽ
extern float data AngleX,AngleY;

u8	xdata	tmp[20];

//========================================================================
// : void	DisableEEPROM(void)
// : ֹISP/IAP.
// : non.
// : non.
// 汾: V1.0, 2012-10-22
//========================================================================
void	DisableEEPROM(void)
{
	IAP_CONTR = 0;			//ֹISP/IAP
	IAP_CMD   = 0;			//ȥISP/IAP
	IAP_TRIG  = 0;			//ֹISP/IAP󴥷
	IAP_ADDRH = 0xff;		//0ַֽ
	IAP_ADDRL = 0xff;		//0ַֽڣָEEPROMֹ
}

//========================================================================
// : void EEPROM_read_n(u16 EE_address,u8 *DataAddress,u16 number)
// : ָEEPROM׵ַnֽڷָĻ.
// : EE_address:  EEPROM׵ַ.
//       DataAddress: ݷŻ׵ַ.
//       number:      ֽڳ.
// : non.
// 汾: V1.0, 2012-10-22
//========================================================================

void EEPROM_read_n(u16 EE_address,u8 *DataAddress,u16 number)
{
	F0 = EA;
	EA = 0;		//ֹж
	IAP_CONTR = ENABLE_IAP;
	IAP_CMD   = CMD_READ;
	do
	{
		IAP_ADDRH = EE_address / 256;		//͵ַֽڣַҪıʱ͵ַ
		IAP_ADDRL = EE_address % 256;		//͵ַֽ
		IAP_TRIG  = 0x5a;	IAP_TRIG  = 0xa5;
		_nop_();
		*DataAddress = IAP_DATA;			//
		EE_address++;
		DataAddress++;
	}while(--number);

	DisableEEPROM();
	EA = F0;		//ж
}


/********************  *****************/
//========================================================================
// : void EEPROM_SectorErase(u16 EE_address)
// : ַָEEPROM.
// : EE_address:  ҪEEPROMĵַ.
// : non.
// 汾: V1.0, 2013-5-10
//========================================================================
void EEPROM_SectorErase(u16 EE_address)
{
	F0 = EA;
	EA = 0;		//ֹж
	IAP_ADDRH = EE_address / 256;			//ַֽڣַҪıʱ͵ַ
	IAP_ADDRL = EE_address % 256;			//ַֽ
	IAP_CONTR = ENABLE_IAP;
	IAP_CMD   = CMD_ERASE;
	IAP_TRIG  = 0x5a;	IAP_TRIG  = 0xa5;
	_nop_();
	DisableEEPROM();
	EA = F0;		//ж
}

//========================================================================
// : void EEPROM_write_n(u16 EE_address,u8 *DataAddress,u16 number)
// : ѻnֽдָ׵ַEEPROM.
// : EE_address:  дEEPROM׵ַ.
//       DataAddress: дԴݵĻ׵ַ.
//       number:      дֽڳ.
// : non.
// 汾: V1.0, 2012-10-22
//========================================================================
void EEPROM_write_n(u16 EE_address,u8 *DataAddress,u16 number)
{
	F0 = EA;
	EA = 0;		//ֹж
	IAP_CONTR = ENABLE_IAP;
	IAP_CMD   = CMD_PROGRAM;
	do
	{
		IAP_ADDRH = EE_address / 256;		//͵ַֽڣַҪıʱ͵ַ
		IAP_ADDRL = EE_address % 256;		//͵ַֽ
		IAP_DATA  = *DataAddress;			//ݵIAP_DATAֻݸıʱ
		IAP_TRIG  = 0x5a;	IAP_TRIG  = 0xa5;
		_nop_();
		EE_address++;
		DataAddress++;
	}while(--number);

	DisableEEPROM();
	EA = F0;		//ж
}


void IAP_Gyro(void)   //У׼
{
	u8	i,j;
	((int *)&tmp)[0] = g_x;	//ȡ
	((int *)&tmp)[1] = g_y; 
	((int *)&tmp)[2] = g_z;
	((int *)&tmp)[3] = 0x55aa;

	((float *)&tmp)[2] = a_x;
	((float *)&tmp)[3] = a_y;

	for(i=0,j=0; i<16; i++)	j += tmp[i];
	j = ~j + 1;
	tmp[i] = j;

	EEPROM_SectorErase(EE_ADDRESS1); //
	EEPROM_write_n(EE_ADDRESS1, tmp, 17);
}

void IAPRead(void)		//ȡǾ
{
	u8	i,j;

	EEPROM_read_n(EE_ADDRESS1, tmp, 17);
	for(i=0,j=0; i<17; i++)	j += tmp[i];

	if((j == 0) && (((int *)&tmp)[3] == 0x55aa))		//жǷѾ¹¹Ŷȡ
	{
		g_x = ((int *)&tmp)[0];
		g_y = ((int *)&tmp)[1];
		g_z = ((int *)&tmp)[2];
		a_x = ((float *)&tmp)[2];
		a_y = ((float *)&tmp)[3];
	}
	else
	{
		g_x = 0;
		g_y = 0;
		g_z = 0;
		a_x = 0;
		a_y = 0;
	}

}

